<%
'*******************************************************************************************'
'IWWB REST Service, Windows / IIS / ADO'
'Author: Michael Weisheit'
'(c) 2003 Engine GmbH & Co KG'
'Contact: mw@engine.de'
'*******************************************************************************************'

Dim gConnection
Dim gBinaryTypeArray

gBinaryTypeArray = Array(128, 204, 205)

Sub CloseMyConnection
	gConnection.Close
	Set gConnection = Nothing
End Sub

Sub OpenMyConnection(strConnection)
	On Error Resume Next
	dim strText
	strText = "Connection-Error : " & strConnection
	Set gConnection = Server.CreateObject("ADODB.Connection")
	gConnection.ConnectionTimeOut = 15
	gConnection.CommandTimeOut = 30
	gConnection.Open strConnection
	If Err <> 0 Then
		Call WriteErrorDescription(Err,strText)
	End If
End Sub

Sub WriteErrorDescription(Err,strText)
	Dim myHTMLstr

	Call WriteHeaderXML()

	myHTMLstr = "<iwwb:error>" & vbCrLf

	myHTMLstr = myHTMLstr & "<iwwb:errorNumber>" & Err.number & "</iwwb:errorNumber>" & vbCrLf
	myHTMLstr = myHTMLstr & "<iwwb:errorDescription>" & Replace(Replace(Replace(Replace(Replace(Err.Description,"'","&apos;"),"&","&amp;"), "<", "&lt;"), ">", "&gt;"), """", "&quot;") & "</iwwb:errorDescription>" & vbCrLf
	myHTMLstr = myHTMLstr & "<iwwb:errorText>" & Replace(Replace(Replace(Replace(Replace(strText,"'","&apos;"),"&","&amp;"), "<", "&lt;"), ">", "&gt;"), """", "&quot;") & "</iwwb:errorText>" & vbCrLf
	myHTMLstr = myHTMLstr & "</iwwb:error>" & vbCrLf
	myHTMLstr = myHTMLstr & "</iwwb:courses>" & vbCrlf
	Response.Write myHTMLstr
	Response.End
End Sub

Sub WriteSchemaXML()
	On Error Resume Next

	Call WriteHeaderXML()

	myXMLstr = myXMLstr & "<!DOCTYPE iwwb:courses [" & vbCrlf
	myXMLstr = myXMLstr & "<!ELEMENT iwwb:course (COURSE+)>" & vbCrlf
	myXMLstr = myXMLstr & "<!ELEMENT iwwb:course ("

	For i = 0 To myFieldCount - 1
		myFieldName = Replace(Replace(Replace(myRS.Fields(i).Name, " ", "_"), "'", "_"), """", "_")
		myXMLstr = myXMLstr & myFieldName & ", "
	Next
	myXMLstr = Left(myXMLstr, Len(myXMLstr)-2) & ")>" & vbCrlf
	For i = 0 To myFieldCount - 1
		myFieldName = Replace(Replace(Replace(myRS.Fields(i).Name, " ", "_"), "'", "_"), """", "_")
		myXMLstr = myXMLstr & "<!ELEMENT " & myFieldName & " (#PCDATA)>" & vbCrlf
	Next

	myXMLstr = myXMLstr & vbCrlf & "<!ENTITY Info ""XML Export for IWWB"">" & vbCrlf
	myXMLstr = myXMLstr & "<!ENTITY Author ""M.Weisheit, www.engine.de"">" & vbCrlf
	myXMLstr = myXMLstr & "]>" & vbCrlf & vbCrlf
'	myRS.Close
	Response.Write myXMLstr
End Sub

Function MyGetOne(pArray, pStr)
	Dim i
	If IsArray(pArray) Then
		MyGetOne = -13
		For i = 0 To UBound(pArray)
			If pStr = pArray(i) Then
				MyGetOne = i
				Exit For
			End If
		Next
	Else
		MyGetOne = -13
	End If
End Function

Function MyIsEmpty(pStr)
	If pStr = "" Or VarType(pStr)= vbNull Or IsNull(pStr)Then
		MyIsEmpty = TRUE
	Else
		MyIsEmpty = FALSE
	End if
End Function

Sub WriteLastIDAsXML()

		Call WriteHeaderXML()

		myXMLstr = "<iwwb:Courses>" & vbCrlf
		Response.Write myXMLstr
		myXMLstr = vbCrlf & "<iwwb:course>" & vbCrlf
		myXMLstr = myXMLstr & "iwwb:<pid1>" & clng(Session("PID1")) & "</iwwb:pid1>" & vbCrlf
		myXMLstr = myXMLstr & "iwwb:<pid2>" & clng(Session("PID2")) & "</iwwb:pid2>" & vbCrlf
		myXMLstr = myXMLstr & "</iwwb:course>" & vbCrlf
		Response.Write myXMLstr
		myXMLstr = vbCrlf & "</iwwb:courses>" & vbCrlf
		Response.Write myXMLstr

end Sub
Sub WriteHeaderXML()

	Server.ScriptTimeout = 900000

	Response.AddHeader "Content-disposition", "filename=iwwbXML.xml_"
	Response.AddHeader "Content-type", "text/xml" & "; charset=" & strCharEncoding
	Response.AddHeader "XCharset",strCharEncoding
	Response.AddHeader "Pragma", "no-cache"
	Response.AddHeader "Expires", "0"
	myXMLstr = "<?xml version=""1.0"" encoding=""" & strCharEncoding & """?>" & vbCrlf
	myXMLstr = myXMLstr & "<iwwb:courses xmlns:iwwb=""http://www.iwwb.de\"">" & vbCrLf
	Response.Write myXMLstr

End Sub
Sub WriteContentXML()
	on error resume next

	Do While Not myRS.EOF
		myXMLstr = vbCrlf & "<iwwb:course>" & vbCrlf
		For i = 0 To myFieldCount - 1

			If MyGetOne(gBinaryTypeArray, myRS.Fields(i).Type) <0 Then
				myValue = myRS(i)
				If Not MyIsEmpty(myValue) Then
					'myValue = Server.HTMLEncode(CStr(myValue))
					myValue = Replace(Replace(Replace(Replace(Replace(myvalue,"'","&apos;"),"&","&amp;"), "<", "&lt;"), ">", "&gt;"), """", "&quot;")
				End If
			Else
				'if myRS.Fields(i).Type <> 128 then ' Timestamp
					myValue = Empty
				'end if
			End If
			myFieldName = LCase(Replace(Replace(Replace(myRS.Fields(i).Name, " ", "_"), "'", "_"), """", "_"))
			myXMLstr = myXMLstr & "<" & myFieldName & ">" & myValue & "</" & myFieldName & ">" & vbCrlf
		Next
		myXMLstr = myXMLstr & "</iwwb:course>" & vbCrlf
		Response.Write myXMLstr
		myRS.MoveNext
	Loop
	myRS.MoveLast
	myXMLstr = "<iwwb:lastpid>" & vbCrlf
	myXMLstr = myXMLstr & "<pid1>" & ltrim(rtrim(myRS.Fields(strIDFeld1Name).Value))  & "</pid1>" & vbCrLf
	if strIDFeld2Name <> "" then
		myXMLstr = myXMLstr & "<pid2>" & ltrim(rtrim(myRS.Fields(strIDFeld2Name).Value))  & "</pid2>" & vbCrLf
	end if
	myXMLstr = myXMLstr & "</iwwb:lastpid>" & vbCrlf
	Response.Write myXMLstr
	myXMLstr = vbCrlf & "</iwwb:courses>" & vbCrlf
	Response.Write myXMLstr

End Sub
%>